// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.15.0
// source: setting.sql

package database

import (
	"context"
	"database/sql"
	"time"
)

const settingBookableDayIndex = `-- name: SettingBookableDayIndex :many

SELECT date, house_id, price_id, restriction_reason FROM bookable_days
WHERE house_id = ? AND date >= ?
ORDER BY date ASC
`

type SettingBookableDayIndexParams struct {
	HouseID string
	Date    string
}

// BOOKABLE DAYS
func (q *Queries) SettingBookableDayIndex(ctx context.Context, arg SettingBookableDayIndexParams) ([]BookableDay, error) {
	rows, err := q.db.QueryContext(ctx, settingBookableDayIndex, arg.HouseID, arg.Date)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookableDay
	for rows.Next() {
		var i BookableDay
		if err := rows.Scan(
			&i.Date,
			&i.HouseID,
			&i.PriceID,
			&i.RestrictionReason,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingBookableDayUpdate = `-- name: SettingBookableDayUpdate :exec

UPDATE bookable_days SET price_id = ?
WHERE house_id = ? AND date >= ? AND date < ?
`

type SettingBookableDayUpdateParams struct {
	PriceID string
	HouseID string
	Start   string
	EndDate string
}

// SettingBookableDayCreate see settings.go
func (q *Queries) SettingBookableDayUpdate(ctx context.Context, arg SettingBookableDayUpdateParams) error {
	_, err := q.db.ExecContext(ctx, settingBookableDayUpdate,
		arg.PriceID,
		arg.HouseID,
		arg.Start,
		arg.EndDate,
	)
	return err
}

const settingBookableHouseIndex = `-- name: SettingBookableHouseIndex :many
SELECT houses.id, houses.name, houses.created_at, houses.max_person, houses.start_minute, houses.end_minute, houses.reply_to, houses.days_for_user_confirmation, houses.months_for_public_booking, houses.public_booking_type, house_user.role FROM houses
JOIN house_user ON houses.id = house_user.house_id and house_user.user_id = ? and house_user.role IN (
    'booking_create',
    'booking_read',
    'booking_admin',
    'admin'
)
ORDER BY id
`

type SettingBookableHouseIndexRow struct {
	ID                      string
	Name                    string
	CreatedAt               time.Time
	MaxPerson               int32
	StartMinute             int32
	EndMinute               int32
	ReplyTo                 string
	DaysForUserConfirmation int32
	MonthsForPublicBooking  int32
	PublicBookingType       string
	Role                    string
}

func (q *Queries) SettingBookableHouseIndex(ctx context.Context, userID string) ([]SettingBookableHouseIndexRow, error) {
	rows, err := q.db.QueryContext(ctx, settingBookableHouseIndex, userID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []SettingBookableHouseIndexRow
	for rows.Next() {
		var i SettingBookableHouseIndexRow
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.CreatedAt,
			&i.MaxPerson,
			&i.StartMinute,
			&i.EndMinute,
			&i.ReplyTo,
			&i.DaysForUserConfirmation,
			&i.MonthsForPublicBooking,
			&i.PublicBookingType,
			&i.Role,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingChargeCreate = `-- name: SettingChargeCreate :exec
INSERT INTO charges (
    id, house_id, price_id, name, description, unit, amount, min_person_charged, charged_over_person_count, exempted_under_age, optionality
)
VALUES (
    ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?
)
`

type SettingChargeCreateParams struct {
	ID                     string
	HouseID                string
	PriceID                string
	Name                   string
	Description            string
	Unit                   string
	Amount                 int32
	MinPersonCharged       int32
	ChargedOverPersonCount int32
	ExemptedUnderAge       int32
	Optionality            string
}

func (q *Queries) SettingChargeCreate(ctx context.Context, arg SettingChargeCreateParams) error {
	_, err := q.db.ExecContext(ctx, settingChargeCreate,
		arg.ID,
		arg.HouseID,
		arg.PriceID,
		arg.Name,
		arg.Description,
		arg.Unit,
		arg.Amount,
		arg.MinPersonCharged,
		arg.ChargedOverPersonCount,
		arg.ExemptedUnderAge,
		arg.Optionality,
	)
	return err
}

const settingChargeDelete = `-- name: SettingChargeDelete :exec
DELETE FROM charges
WHERE id = ?
`

func (q *Queries) SettingChargeDelete(ctx context.Context, id string) error {
	_, err := q.db.ExecContext(ctx, settingChargeDelete, id)
	return err
}

const settingChargeIndexPerHousePrice = `-- name: SettingChargeIndexPerHousePrice :many
SELECT id, name, description, house_id, price_id, unit, amount, min_person_charged, charged_over_person_count, exempted_under_age, optionality, created_at, deleted_at FROM charges
WHERE price_id = ? AND house_id = ?
ORDER BY optionality, name ASC
`

type SettingChargeIndexPerHousePriceParams struct {
	PriceID string
	HouseID string
}

func (q *Queries) SettingChargeIndexPerHousePrice(ctx context.Context, arg SettingChargeIndexPerHousePriceParams) ([]Charge, error) {
	rows, err := q.db.QueryContext(ctx, settingChargeIndexPerHousePrice, arg.PriceID, arg.HouseID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Charge
	for rows.Next() {
		var i Charge
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.Description,
			&i.HouseID,
			&i.PriceID,
			&i.Unit,
			&i.Amount,
			&i.MinPersonCharged,
			&i.ChargedOverPersonCount,
			&i.ExemptedUnderAge,
			&i.Optionality,
			&i.CreatedAt,
			&i.DeletedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingChargeIndexPerPrice = `-- name: SettingChargeIndexPerPrice :many

SELECT id, name, description, house_id, price_id, unit, amount, min_person_charged, charged_over_person_count, exempted_under_age, optionality, created_at, deleted_at FROM charges
WHERE price_id = ?
ORDER BY optionality, name ASC
`

// CHARGE
func (q *Queries) SettingChargeIndexPerPrice(ctx context.Context, priceID string) ([]Charge, error) {
	rows, err := q.db.QueryContext(ctx, settingChargeIndexPerPrice, priceID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Charge
	for rows.Next() {
		var i Charge
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.Description,
			&i.HouseID,
			&i.PriceID,
			&i.Unit,
			&i.Amount,
			&i.MinPersonCharged,
			&i.ChargedOverPersonCount,
			&i.ExemptedUnderAge,
			&i.Optionality,
			&i.CreatedAt,
			&i.DeletedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingChargeUpdate = `-- name: SettingChargeUpdate :exec
UPDATE charges SET
    name = ?, description = ?, unit = ?, amount = ?, min_person_charged = ?, charged_over_person_count = ?, exempted_under_age = ?, optionality = ?
WHERE id = ?
`

type SettingChargeUpdateParams struct {
	Name                   string
	Description            string
	Unit                   string
	Amount                 int32
	MinPersonCharged       int32
	ChargedOverPersonCount int32
	ExemptedUnderAge       int32
	Optionality            string
	ID                     string
}

func (q *Queries) SettingChargeUpdate(ctx context.Context, arg SettingChargeUpdateParams) error {
	_, err := q.db.ExecContext(ctx, settingChargeUpdate,
		arg.Name,
		arg.Description,
		arg.Unit,
		arg.Amount,
		arg.MinPersonCharged,
		arg.ChargedOverPersonCount,
		arg.ExemptedUnderAge,
		arg.Optionality,
		arg.ID,
	)
	return err
}

const settingExtraRequestCreate = `-- name: SettingExtraRequestCreate :exec
INSERT INTO extra_requests (
    house_id, description, pricing, weight
)
VALUES (
    ?, ?, ?, ?
)
`

type SettingExtraRequestCreateParams struct {
	HouseID     string
	Description string
	Pricing     string
	Weight      int32
}

func (q *Queries) SettingExtraRequestCreate(ctx context.Context, arg SettingExtraRequestCreateParams) error {
	_, err := q.db.ExecContext(ctx, settingExtraRequestCreate,
		arg.HouseID,
		arg.Description,
		arg.Pricing,
		arg.Weight,
	)
	return err
}

const settingExtraRequestDelete = `-- name: SettingExtraRequestDelete :exec
DELETE FROM extra_requests
WHERE id = ?
`

func (q *Queries) SettingExtraRequestDelete(ctx context.Context, id int32) error {
	_, err := q.db.ExecContext(ctx, settingExtraRequestDelete, id)
	return err
}

const settingExtraRequestUpdate = `-- name: SettingExtraRequestUpdate :exec
UPDATE extra_requests SET
    description = ?, pricing = ?, weight = ?
WHERE id = ?
`

type SettingExtraRequestUpdateParams struct {
	Description string
	Pricing     string
	Weight      int32
	ID          int32
}

func (q *Queries) SettingExtraRequestUpdate(ctx context.Context, arg SettingExtraRequestUpdateParams) error {
	_, err := q.db.ExecContext(ctx, settingExtraRequestUpdate,
		arg.Description,
		arg.Pricing,
		arg.Weight,
		arg.ID,
	)
	return err
}

const settingHouseCreate = `-- name: SettingHouseCreate :exec

INSERT INTO houses (id,  name, max_person, reply_to)
VALUES (?, ?, ?, ?)
`

type SettingHouseCreateParams struct {
	ID        string
	Name      string
	MaxPerson int32
	ReplyTo   string
}

// HOUSE
func (q *Queries) SettingHouseCreate(ctx context.Context, arg SettingHouseCreateParams) error {
	_, err := q.db.ExecContext(ctx, settingHouseCreate,
		arg.ID,
		arg.Name,
		arg.MaxPerson,
		arg.ReplyTo,
	)
	return err
}

const settingHouseFind = `-- name: SettingHouseFind :one
SELECT id, name, created_at, max_person, start_minute, end_minute, reply_to, days_for_user_confirmation, months_for_public_booking, public_booking_type FROM houses
WHERE id = ?
`

func (q *Queries) SettingHouseFind(ctx context.Context, id string) (House, error) {
	row := q.db.QueryRowContext(ctx, settingHouseFind, id)
	var i House
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.CreatedAt,
		&i.MaxPerson,
		&i.StartMinute,
		&i.EndMinute,
		&i.ReplyTo,
		&i.DaysForUserConfirmation,
		&i.MonthsForPublicBooking,
		&i.PublicBookingType,
	)
	return i, err
}

const settingHouseIndex = `-- name: SettingHouseIndex :many
SELECT id, name, created_at, max_person, start_minute, end_minute, reply_to, days_for_user_confirmation, months_for_public_booking, public_booking_type FROM houses
ORDER BY id
`

func (q *Queries) SettingHouseIndex(ctx context.Context) ([]House, error) {
	rows, err := q.db.QueryContext(ctx, settingHouseIndex)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []House
	for rows.Next() {
		var i House
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.CreatedAt,
			&i.MaxPerson,
			&i.StartMinute,
			&i.EndMinute,
			&i.ReplyTo,
			&i.DaysForUserConfirmation,
			&i.MonthsForPublicBooking,
			&i.PublicBookingType,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingHouseUpdate = `-- name: SettingHouseUpdate :exec
UPDATE houses SET name = ?, max_person = ?, reply_to = ?, start_minute = ?, end_minute = ?, public_booking_type = ?
WHERE id = ?
`

type SettingHouseUpdateParams struct {
	Name              string
	MaxPerson         int32
	ReplyTo           string
	StartMinute       int32
	EndMinute         int32
	PublicBookingType string
	ID                string
}

func (q *Queries) SettingHouseUpdate(ctx context.Context, arg SettingHouseUpdateParams) error {
	_, err := q.db.ExecContext(ctx, settingHouseUpdate,
		arg.Name,
		arg.MaxPerson,
		arg.ReplyTo,
		arg.StartMinute,
		arg.EndMinute,
		arg.PublicBookingType,
		arg.ID,
	)
	return err
}

const settingHouseUserIndex = `-- name: SettingHouseUserIndex :many

SELECT user_id, house_id, role FROM house_user
`

// HOUSE-USER
func (q *Queries) SettingHouseUserIndex(ctx context.Context) ([]HouseUser, error) {
	rows, err := q.db.QueryContext(ctx, settingHouseUserIndex)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []HouseUser
	for rows.Next() {
		var i HouseUser
		if err := rows.Scan(&i.UserID, &i.HouseID, &i.Role); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingHouseUserInsertRole = `-- name: SettingHouseUserInsertRole :exec
INSERT INTO house_user (house_id, user_id, role)
VALUES (?,?,?)
`

type SettingHouseUserInsertRoleParams struct {
	HouseID string
	UserID  string
	Role    string
}

func (q *Queries) SettingHouseUserInsertRole(ctx context.Context, arg SettingHouseUserInsertRoleParams) error {
	_, err := q.db.ExecContext(ctx, settingHouseUserInsertRole, arg.HouseID, arg.UserID, arg.Role)
	return err
}

const settingHouseUserRole = `-- name: SettingHouseUserRole :one
SELECT role FROM house_user
WHERE house_id = ? and user_id = ?
`

type SettingHouseUserRoleParams struct {
	HouseID string
	UserID  string
}

func (q *Queries) SettingHouseUserRole(ctx context.Context, arg SettingHouseUserRoleParams) (string, error) {
	row := q.db.QueryRowContext(ctx, settingHouseUserRole, arg.HouseID, arg.UserID)
	var role string
	err := row.Scan(&role)
	return role, err
}

const settingHouseUserUpdateRole = `-- name: SettingHouseUserUpdateRole :exec
UPDATE house_user SET role = ?
WHERE house_id = ? AND user_id = ?
`

type SettingHouseUserUpdateRoleParams struct {
	Role    string
	HouseID string
	UserID  string
}

func (q *Queries) SettingHouseUserUpdateRole(ctx context.Context, arg SettingHouseUserUpdateRoleParams) error {
	_, err := q.db.ExecContext(ctx, settingHouseUserUpdateRole, arg.Role, arg.HouseID, arg.UserID)
	return err
}

const settingPriceCreate = `-- name: SettingPriceCreate :exec

INSERT INTO prices (id,  name)
VALUES (?, ?)
`

type SettingPriceCreateParams struct {
	ID   string
	Name string
}

// PRICE
func (q *Queries) SettingPriceCreate(ctx context.Context, arg SettingPriceCreateParams) error {
	_, err := q.db.ExecContext(ctx, settingPriceCreate, arg.ID, arg.Name)
	return err
}

const settingPriceFind = `-- name: SettingPriceFind :one
SELECT id, name, created_at, hidden_at FROM prices
WHERE id = ?
`

func (q *Queries) SettingPriceFind(ctx context.Context, id string) (Price, error) {
	row := q.db.QueryRowContext(ctx, settingPriceFind, id)
	var i Price
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.CreatedAt,
		&i.HiddenAt,
	)
	return i, err
}

const settingPriceHasBooking = `-- name: SettingPriceHasBooking :one
SELECT EXISTS(SELECT 1 FROM bookable_days
    JOIN bookings
    ON bookings.house_id = bookable_days.house_id
        AND date(bookable_days.date, '+1 day') >= bookings.start_at AND bookable_days.date < bookings.end_at
    WHERE bookable_days.house_id = ?
        AND bookable_days.price_id = ?
)
`

type SettingPriceHasBookingParams struct {
	HouseID string
	PriceID string
}

func (q *Queries) SettingPriceHasBooking(ctx context.Context, arg SettingPriceHasBookingParams) (bool, error) {
	row := q.db.QueryRowContext(ctx, settingPriceHasBooking, arg.HouseID, arg.PriceID)
	var exists bool
	err := row.Scan(&exists)
	return exists, err
}

const settingPriceIndex = `-- name: SettingPriceIndex :many
SELECT id, name, created_at, hidden_at FROM prices
ORDER BY created_at DESC
`

func (q *Queries) SettingPriceIndex(ctx context.Context) ([]Price, error) {
	rows, err := q.db.QueryContext(ctx, settingPriceIndex)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Price
	for rows.Next() {
		var i Price
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.CreatedAt,
			&i.HiddenAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingPriceIndexActive = `-- name: SettingPriceIndexActive :many
SELECT id, name, created_at, hidden_at FROM prices
WHERE hidden_at IS NULL
ORDER BY created_at ASC
`

func (q *Queries) SettingPriceIndexActive(ctx context.Context) ([]Price, error) {
	rows, err := q.db.QueryContext(ctx, settingPriceIndexActive)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Price
	for rows.Next() {
		var i Price
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.CreatedAt,
			&i.HiddenAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingPriceUpdate = `-- name: SettingPriceUpdate :exec
UPDATE prices SET name = ?, hidden_at = ?
WHERE id = ?
`

type SettingPriceUpdateParams struct {
	Name     string
	HiddenAt sql.NullTime
	ID       string
}

func (q *Queries) SettingPriceUpdate(ctx context.Context, arg SettingPriceUpdateParams) error {
	_, err := q.db.ExecContext(ctx, settingPriceUpdate, arg.Name, arg.HiddenAt, arg.ID)
	return err
}

const settingRestDayIndex = `-- name: SettingRestDayIndex :many
SELECT date, house_id, price_id, restriction_reason FROM bookable_days
WHERE house_id = ? AND date >= ? AND restriction_reason <> ''
ORDER BY date ASC
`

type SettingRestDayIndexParams struct {
	HouseID string
	Date    string
}

func (q *Queries) SettingRestDayIndex(ctx context.Context, arg SettingRestDayIndexParams) ([]BookableDay, error) {
	rows, err := q.db.QueryContext(ctx, settingRestDayIndex, arg.HouseID, arg.Date)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []BookableDay
	for rows.Next() {
		var i BookableDay
		if err := rows.Scan(
			&i.Date,
			&i.HouseID,
			&i.PriceID,
			&i.RestrictionReason,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingRestDayUpdate = `-- name: SettingRestDayUpdate :exec
UPDATE bookable_days SET restriction_reason = ?
WHERE house_id = ? AND date >= ? AND date < ?
`

type SettingRestDayUpdateParams struct {
	RestrictionReason string
	HouseID           string
	Start             string
	EndDate           string
}

func (q *Queries) SettingRestDayUpdate(ctx context.Context, arg SettingRestDayUpdateParams) error {
	_, err := q.db.ExecContext(ctx, settingRestDayUpdate,
		arg.RestrictionReason,
		arg.HouseID,
		arg.Start,
		arg.EndDate,
	)
	return err
}

const settingUserFind = `-- name: SettingUserFind :one
SELECT id, email, name, created_at, authorized_at, role FROM users
WHERE id = ?
`

func (q *Queries) SettingUserFind(ctx context.Context, id string) (User, error) {
	row := q.db.QueryRowContext(ctx, settingUserFind, id)
	var i User
	err := row.Scan(
		&i.ID,
		&i.Email,
		&i.Name,
		&i.CreatedAt,
		&i.AuthorizedAt,
		&i.Role,
	)
	return i, err
}

const settingUserHouseRoles = `-- name: SettingUserHouseRoles :many
SELECT houses.id as house_id, role FROM houses
LEFT JOIN house_user ON houses.id = house_user.house_id and house_user.user_id = ?
`

type SettingUserHouseRolesRow struct {
	HouseID string
	Role    sql.NullString
}

func (q *Queries) SettingUserHouseRoles(ctx context.Context, userID string) ([]SettingUserHouseRolesRow, error) {
	rows, err := q.db.QueryContext(ctx, settingUserHouseRoles, userID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []SettingUserHouseRolesRow
	for rows.Next() {
		var i SettingUserHouseRolesRow
		if err := rows.Scan(&i.HouseID, &i.Role); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingUserIndex = `-- name: SettingUserIndex :many

SELECT id, email, name, created_at, authorized_at, role FROM users
ORDER BY name
`

// USER
func (q *Queries) SettingUserIndex(ctx context.Context) ([]User, error) {
	rows, err := q.db.QueryContext(ctx, settingUserIndex)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []User
	for rows.Next() {
		var i User
		if err := rows.Scan(
			&i.ID,
			&i.Email,
			&i.Name,
			&i.CreatedAt,
			&i.AuthorizedAt,
			&i.Role,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const settingUserUpdate = `-- name: SettingUserUpdate :exec
UPDATE users SET authorized_at = ?, role = ?
WHERE id = ?
`

type SettingUserUpdateParams struct {
	AuthorizedAt sql.NullTime
	Role         string
	ID           string
}

func (q *Queries) SettingUserUpdate(ctx context.Context, arg SettingUserUpdateParams) error {
	_, err := q.db.ExecContext(ctx, settingUserUpdate, arg.AuthorizedAt, arg.Role, arg.ID)
	return err
}

const settingViewableHouseIndex = `-- name: SettingViewableHouseIndex :many
SELECT houses.id, houses.name, houses.created_at, houses.max_person, houses.start_minute, houses.end_minute, houses.reply_to, houses.days_for_user_confirmation, houses.months_for_public_booking, houses.public_booking_type, house_user.role FROM houses
JOIN house_user ON houses.id = house_user.house_id and house_user.user_id = ? and house_user.role IN (
    'booking_read',
    'booking_admin',
    'admin'
)
ORDER BY id
`

type SettingViewableHouseIndexRow struct {
	ID                      string
	Name                    string
	CreatedAt               time.Time
	MaxPerson               int32
	StartMinute             int32
	EndMinute               int32
	ReplyTo                 string
	DaysForUserConfirmation int32
	MonthsForPublicBooking  int32
	PublicBookingType       string
	Role                    string
}

func (q *Queries) SettingViewableHouseIndex(ctx context.Context, userID string) ([]SettingViewableHouseIndexRow, error) {
	rows, err := q.db.QueryContext(ctx, settingViewableHouseIndex, userID)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []SettingViewableHouseIndexRow
	for rows.Next() {
		var i SettingViewableHouseIndexRow
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.CreatedAt,
			&i.MaxPerson,
			&i.StartMinute,
			&i.EndMinute,
			&i.ReplyTo,
			&i.DaysForUserConfirmation,
			&i.MonthsForPublicBooking,
			&i.PublicBookingType,
			&i.Role,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
